#R code to generate MMAP demo data

#The original data are from GAPIT demo
#Numerica genotype: mdp_numeric.txt
#Genetic map: mdp_map.txt
#Penotype with 3 traits: mdp_traits.txt

#Simulated data
#Environment factors: mdp_env.txt
#First 3 PCs: mdp_PCA.csv
#Combined ENV and PCS: mdp_env&PCs.csv
#Simulated Y and BV: mdp_Y&BV.txt
#Simulate Y(80%): mdp_YRef.txt

source("http://zzlab.net/GAPIT/GAPIT.library.R")
source("http://www.zzlab.net/GAPIT/gapit_functions.txt")
myGD=read.table(file="http://zzlab.net/GAPIT/data/mdp_numeric.txt",head=T)
myGM=read.table(file="http://zzlab.net/GAPIT/data/mdp_SNP_information.txt",head=T)
myCV=read.table(file="http://zzlab.net/GAPIT/data/mdp_env.txt",head=T)

#Simultate 10 QTN on the first half chromosomes
X=myGD[,-1]
index1to5=myGM[,2]<6
X1to5 = X[,index1to5]
taxa=myGD[,1]
GD.candidate=cbind(taxa,X1to5)
nqtn=20

setwd("~/Desktop/temp")
set.seed(99164)
mySim=GAPIT.Phenotype.Simulation(GD=GD.candidate,GM=myGM[index1to5,],h2=.75,NQTN=nqtn, effectunit =.95,QTNDist="normal",CV=myCV,cveff=c(.1,.1))

#Cross validation
set.seed(99164)
n=nrow(mySim$Y)
testing=sample(n,round(n/5),replace=F)
training=-testing
nr=length(mySim$Y[training,1])

write.table(mySim$Y[training,], file="mdp_YRef.txt", sep="\t",quote=F,row.names=F)
write.table(cbind(mySim$Y,mySim$u),file="mdp_Y&BV.txt", sep="\t",quote=F,row.names=F)
